Index: trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 71104)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 71105)
@@ -377,4 +377,5 @@
 	src/runtime/information/UIVMInformationDialog.h \
 	src/runtime/information/guestctrl/UIGuestControlConsole.h \
+	src/runtime/information/guestctrl/UIGuestControlFileManager.h \
 	src/runtime/information/guestctrl/UIGuestControlInterface.h \
 	src/runtime/information/guestctrl/UIGuestControlTreeItem.h \
@@ -565,4 +566,5 @@
 	src/runtime/UIIndicatorsPool.cpp \
 	src/runtime/UIStatusBarEditorWindow.cpp \
+	src/runtime/information/guestctrl/UIGuestControlFileManager.cpp \
 	src/runtime/information/guestctrl/UIGuestControlWidget.cpp \
 	src/selector/UIActionPoolSelector.cpp \
@@ -707,4 +709,5 @@
 	src/runtime/information/UIVMInformationDialog.cpp \
 	src/runtime/information/guestctrl/UIGuestControlConsole.cpp \
+	src/runtime/information/guestctrl/UIGuestControlFileManager.cpp \
 	src/runtime/information/guestctrl/UIGuestControlInterface.cpp \
 	src/runtime/information/guestctrl/UIGuestControlTreeItem.cpp \
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp	(revision 71104)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp	(revision 71105)
@@ -38,4 +38,5 @@
 # include "VBoxUtils.h"
 # include "UIInformationConfiguration.h"
+# include "UIGuestControlFileManager.h"
 # include "UIGuestControlWidget.h"
 # include "UIInformationRuntime.h"
@@ -119,4 +120,5 @@
     m_pTabWidget->setTabText(1, tr("&Runtime Information"));
     m_pTabWidget->setTabText(2, tr("&Guest Session"));
+    m_pTabWidget->setTabText(3, tr("&Guest File Manager"));
 }
 
@@ -253,4 +255,16 @@
             }
         }
+        if(m_pMachineWindow->console().isOk())
+        {
+            UIGuestControlFileManager *pGuestControlFileManager =
+                new  UIGuestControlFileManager(this, m_pMachineWindow->console().GetGuest());
+            if (pGuestControlFileManager)
+            {
+                m_tabs.insert(3, pGuestControlFileManager);
+                m_pTabWidget->addTab(m_tabs.value(3), QString());
+            }
+        }
+
+
         /* Set Runtime Information tab as default: */
         m_pTabWidget->setCurrentIndex(1);
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/guestctrl/UIGuestControlFileManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/guestctrl/UIGuestControlFileManager.cpp	(revision 71105)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/guestctrl/UIGuestControlFileManager.cpp	(revision 71105)
@@ -0,0 +1,184 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UIGuestControlFileManager class implementation.
+ */
+
+/*
+ * Copyright (C) 2016-2017 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+#ifdef VBOX_WITH_PRECOMPILED_HEADERS
+# include <precomp.h>
+#else  /* !VBOX_WITH_PRECOMPILED_HEADERS */
+
+/* Qt includes: */
+# include <QSplitter>
+# include <QHBoxLayout>
+# include <QVBoxLayout>
+
+/* GUI includes: */
+# include "QILabel.h"
+# include "QILineEdit.h"
+# include "QIToolButton.h"
+# include "QIWithRetranslateUI.h"
+# include "UIGuestControlFileManager.h"
+# include "UIVMInformationDialog.h"
+# include "VBoxGlobal.h"
+
+/* COM includes: */
+# include "CGuest.h"
+
+#endif /* !VBOX_WITH_PRECOMPILED_HEADERS */
+
+class UIGuestSessionCreateWidget : public QIWithRetranslateUI<QWidget>
+{
+    Q_OBJECT;
+
+public:
+
+    UIGuestSessionCreateWidget(QWidget *pParent = 0);
+
+protected:
+
+    void retranslateUi();
+
+private:
+    void         prepareWidgets();
+    QILineEdit   *m_pUserNameEdit;
+    QILineEdit   *m_pPasswordEdit;
+
+    QILabel      *m_pUserNameLabel;
+    QILabel      *m_pPasswordLabel;
+    QIToolButton *m_pCreateButton;
+
+    QHBoxLayout *m_pMainLayout;
+
+};
+
+UIGuestSessionCreateWidget::UIGuestSessionCreateWidget(QWidget *pParent /* = 0 */)
+    : QIWithRetranslateUI<QWidget>(pParent)
+    , m_pUserNameEdit(0)
+    , m_pPasswordEdit(0)
+    , m_pUserNameLabel(0)
+    , m_pPasswordLabel(0)
+    , m_pCreateButton(0)
+    , m_pMainLayout(0)
+{
+    prepareWidgets();
+}
+
+void UIGuestSessionCreateWidget::prepareWidgets()
+{
+    m_pMainLayout = new QHBoxLayout(this);
+    if (!m_pMainLayout)
+        return;
+    m_pUserNameEdit = new QILineEdit;
+    if (m_pUserNameEdit)
+    {
+        m_pMainLayout->addWidget(m_pUserNameEdit);
+    }
+    m_pUserNameLabel = new QILabel;
+    if (m_pUserNameLabel)
+    {
+        m_pMainLayout->addWidget(m_pUserNameLabel);
+    }
+    m_pPasswordEdit = new QILineEdit;
+    if (m_pPasswordEdit)
+    {
+        m_pMainLayout->addWidget(m_pPasswordEdit);
+    }
+
+    m_pPasswordLabel = new QILabel;
+    if (m_pPasswordLabel)
+    {
+        m_pMainLayout->addWidget(m_pPasswordLabel);
+    }
+
+    m_pCreateButton = new QIToolButton;
+    if (m_pCreateButton)
+    {
+        m_pMainLayout->addWidget(m_pCreateButton);
+    }
+    retranslateUi();
+}
+
+void UIGuestSessionCreateWidget::retranslateUi()
+{
+    if (m_pUserNameEdit)
+    {
+        m_pUserNameEdit->setToolTip(UIVMInformationDialog::tr("User name to authenticate session creation"));
+    }
+    if (m_pPasswordEdit)
+    {
+        m_pPasswordEdit->setToolTip(UIVMInformationDialog::tr("Password to authenticate session creation"));
+    }
+    if (m_pUserNameLabel)
+    {
+        m_pUserNameLabel->setToolTip(UIVMInformationDialog::tr("User name to authenticate session creation"));
+        m_pUserNameLabel->setText(UIVMInformationDialog::tr("User name"));
+    }
+    if (m_pPasswordLabel)
+    {
+        m_pPasswordLabel->setToolTip(UIVMInformationDialog::tr("Password to authenticate session creation"));
+        m_pPasswordLabel->setText(UIVMInformationDialog::tr("Password"));
+    }
+    if(m_pCreateButton)
+    {
+        m_pCreateButton->setText(UIVMInformationDialog::tr("Create Session"));
+    }
+}
+
+UIGuestControlFileManager::UIGuestControlFileManager(QWidget *pParent, const CGuest &comGuest)
+    : QWidget(pParent)
+    , m_comGuest(comGuest)
+    , m_pMainLayout(0)
+    , m_pSplitter(0)
+    , m_pSessionCreateWidget(0)
+{
+    prepareObjects();
+    prepareConnections();
+}
+
+void UIGuestControlFileManager::prepareObjects()
+{
+    /* Create layout: */
+    m_pMainLayout = new QVBoxLayout(this);
+    if (!m_pMainLayout)
+        return;
+
+    /* Configure layout: */
+    m_pMainLayout->setSpacing(0);
+
+    m_pSplitter = new QSplitter;
+
+    if (!m_pSplitter)
+        return;
+
+    m_pSessionCreateWidget = new UIGuestSessionCreateWidget();
+    if (m_pSessionCreateWidget)
+    {
+        m_pSplitter->addWidget(m_pSessionCreateWidget);
+    }
+
+    m_pSplitter->setOrientation(Qt::Vertical);
+    m_pMainLayout->addWidget(m_pSplitter);
+
+
+    // m_pSplitter->setStretchFactor(0, 9);
+    // m_pSplitter->setStretchFactor(1, 4);
+}
+
+void UIGuestControlFileManager::prepareConnections()
+{
+
+}
+
+#include "UIGuestControlFileManager.moc"
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/guestctrl/UIGuestControlFileManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/guestctrl/UIGuestControlFileManager.h	(revision 71105)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/guestctrl/UIGuestControlFileManager.h	(revision 71105)
@@ -0,0 +1,54 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UIGuestControlFileManager class declaration.
+ */
+
+/*
+ * Copyright (C) 2016-2017 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+#ifndef ___UIGuestControlFileManager_h___
+#define ___UIGuestControlFileManager_h___
+
+/* Qt includes: */
+#include <QWidget>
+
+/* COM includes: */
+#include "COMEnums.h"
+#include "CGuest.h"
+
+/* Forward declarations: */
+class QVBoxLayout;
+class QSplitter;
+
+
+/** QWidget extension
+  * providing GUI with guest session information and control tab in session-information window. */
+class UIGuestControlFileManager : public QWidget
+{
+    Q_OBJECT;
+
+public:
+
+    UIGuestControlFileManager(QWidget *pParent, const CGuest &comGuest);
+
+private:
+
+    void prepareObjects();
+    void prepareConnections();
+
+    CGuest         m_comGuest;
+    QVBoxLayout   *m_pMainLayout;
+    QSplitter     *m_pSplitter;
+    QWidget       *m_pSessionCreateWidget;
+};
+
+#endif /* !___UIGuestControlFileManager_h___ */